#ifndef FTPTRANSFERCONNECTION_H_
#define FTPTRANSFERCONNECTION_H_

#include <curl/curl.h>
#include <string>

#include "TransferItem.h"

class FTPTransferConnection
{
	private:
		string loginInfo;
		string hostname;
		string rootPath;
		CURLM* multi_handle;
		CURL** item_handles;
		int item_handle_count;
		int numConnections;
		struct curl_slist* commands;
		
		
		string buildDestinationPath(string itemDestinationPath);
		int setupItemHandles(TransferItem** items, int loopItems, int itemPos);
		
	public:
		FTPTransferConnection(int parallelConnections, string hostname, string user, string password, string rootPath);
		virtual ~FTPTransferConnection();
		
	virtual int upload(TransferItem** items, int offset, int item_count);
	virtual int connect();
	virtual int disconnect();
	virtual int connected();
};

#endif /*FTPTRANSFERCONNECTION_H_*/
