#include <vector>
#include <libgen.h>
#include "TransferItem.h"

TransferItem::TransferItem(string sourcePath, string destinationPath)
{
	this->sourcePath = sourcePath;
	this->destinationPath = destinationPath;
	this->sourceFile = NULL;
	this->protocolDestinationPath = "";
	this->transferred = false;
}

TransferItem::~TransferItem()
{
	if (sourceFile != NULL)
	{
		fclose(sourceFile);
		sourceFile = NULL;
	}
}

FILE* TransferItem::getSourceFile()
{
	if (sourceFile == NULL)
	{
		sourceFile = fopen(sourcePath.c_str(), "rb");
	}
	return sourceFile;
}

string TransferItem::getDestinationPath()
{
	return destinationPath;
}

string TransferItem::getSourcePath()
{
	return sourcePath;
}

string TransferItem::getProtocolDestinationPath()
{
	return protocolDestinationPath;
}

void TransferItem::setProtocolDestinationPath(string destinationPath)
{
	this->protocolDestinationPath = destinationPath;
}

void TransferItem::closeFile()
{
	if (sourceFile != NULL)
	{
		fclose(sourceFile);
		sourceFile = NULL;
	}
}

string TransferItem::getDestinationDir()
{
	char * dirnameDst = strdup(destinationPath.data());
	dirname(dirnameDst);
	
	string dirname = dirnameDst;
	free(dirnameDst);
	
	return dirname;
}

void TransferItem::setTransferred()
{
	transferred = true;
}

bool TransferItem::isTransferred()
{
	return transferred;
}

